export default {
    //pnpm dev 使用
    _dev_api: "/",

    //接口网址
    api: "http://127.0.0.1:28978",

    //远程配置文件路径(返回内容和conf.js一样),为空不加载
    conf: 'config',

    //id名,为空随机
    app: 'app',

    //打包目录,默认dist/项目, /开头为自定绝对路径目录
    dist: false,

    //打包要清空目录,保留那些文件或者目录
    exclude: ['.git'],

    //dev模式是否开启mock
    mock: true,

    //视图目录
    view: "view",

    //运行域名
    host: "127.0.0.1",

    //运行端口
    port: "29888",

    //.env文件key前缀,.env要放在config目录内
    prefix: "alone_",

    dts: {
        //是否生成 auto-imports.d.ts
        auto: false,
        //是否生成 components.d.ts
        component: false
    },

    //favicon 为空不加载, /开头为public目录, 默认开发目录/文件
    favicon: "style/vite.svg",

    //layui配置,可选,不设置默认开
    layui: {
        //开关,只有false为关
        status: false
    },

    //打包完成是否压缩成zip
    zip: false,

    /**
     * 打包设置,为空默认开启 aloen,naive,file,chunk
     * 默认处理有 svg vue alone naive file chunk
     * key = 打包名
     * value true       开启默认设置
     * value false      关闭处理
     * value string     路径包含
     * value array      格式包含
     * value function   参数(文件,格式); 返回true设置key为打包名
     * callback object  可以改写 或者 追加方法
     */
    build: {
        //vendor.file体积太大推荐开启
        svg: false,
        //vendor.chunk体积太大推荐开启
        vue: false,
        //vendor.chunk体积太大推荐开启
        alone: true,
        //vendor.chunk体积太大推荐开启
        naive: true,
        //图片,字体,音频,视频打包成vendor.file
        file: true,
        //组件打包成vendor.chunk
        chunk: true,
        //callback可以改写或者追加方法
        callback: {}
    },
}