import alone from "./alone.js";

export default {
    //time为有效时间/秒
    set(key, val, time = 0, {path = '/', domain = null} = {}) {
        const value = alone.to_str(val);
        let cookie = `${key}=${encodeURIComponent(alone.to_str(val))}`;
        if (time > 0) {
            const expires = new Date(Date.now() + time * 1000).toUTCString();
            cookie += `; expires=${expires}`;
        }
        document.cookie = `${cookie}; path=${path}; domain=${domain || document.domain};`;
        return value;
    },
    get(key = null, def = null) {
        return alone.get_arr(this.list(), key, def);
    },
    del(key, {path = '/', domain = null} = {}) {
        const remove = function (k) {
            document.cookie = `${k}=; path=${path}; domain=${domain || document.domain}; expires=Thu, 01 Jan 1970 00:00:00 UTC;`;
        }
        if (alone.isset(key)) {
            if (alone.is_array(key)) {
                key.forEach((k) => remove(k));
            } else {
                remove(key);
            }
        }
    },
    delete() {
        this.del(Object.keys(this.list()));
    },
    list() {
        const list = (document.cookie || '').split("; ");
        return alone.isset(list) ? (list.reduce((acc, curr) => {
            const [key, val] = curr.split("=");
            const value = alone.to_obj(decodeURIComponent(val));
            if (key && alone.isset(value)) {
                acc[key] = value;
            }
            return acc;
        }, {})) : {};
    }
}