import alone from "./alone.js";

export const global = function (name = null, symbol = ".") {
    return {
        symbol: alone.isset(symbol) ? symbol : ".",
        name: "global_" + (alone.isset(name) ? name : "_app_object") + "_cache",
        //设置
        set(key, val = null) {
            const value = alone.is_object(key) ? key : alone.set_arr(key, val, this.symbol);
            this.object(value);
            return value;
        },
        //获取
        get(key = null, def = null) {
            return alone.get_arr(this.list(), key, def, this.symbol) || def;
        },
        //删除,支持传入array删除多个,返回删除数量
        del(key) {
            if (alone.isset(key)) {
                if (alone.is_array(key)) {
                    key.forEach((k) => this.save(alone.del_key(this.list(), k, this.symbol)));
                } else {
                    this.save(alone.del_key(this.list(), key, this.symbol));
                }
            }
        },
        //清空
        delete() {
            window[this.name] = {};
        },
        //获取全部
        list() {
            return window[this.name] || {};
        },
        //传入对像合并,true=优选
        object(object = {}, merge = false) {
            return this.save((merge ? alone.array_merge(object, this.list()) : alone.array_merge(this.list(), object)));
        },
        //保存
        save(object) {
            window[this.name] = object;
            return object;
        }
    };
};
export default global('vite_vue');