import alone from "./alone.js";

export default {
    set(key, val) {
        const value = alone.to_str(val);
        window.sessionStorage.setItem(key, value);
        return value;
    },
    get(key = null, def = null) {
        return alone.get_arr(this.list(), key, def);
    },
    del(key) {
        if (alone.isset(key)) {
            if (alone.is_array(key)) {
                key.forEach((k) => window.sessionStorage.removeItem(k));
            } else {
                window.sessionStorage.removeItem(key);
            }
        }
    },
    delete() {
        window.sessionStorage.clear();
    },
    list() {
        const arr = {};
        const obj = window.sessionStorage;
        Object.keys(obj).forEach((key) => {
            const val = alone.to_obj(obj[key]);
            if (key && alone.isset(val)) {
                arr[key] = val;
            }
        });
        return arr;
    }
}