import alone from "./alone.js";

export default {
    set(key, val, time = 0) {
        window.localStorage.setItem(key, alone.to_str({
            data: val,
            time: ((time || 0) > 0 ? (alone.get_time() + time) : 0)
        }));
        return val;
    },
    get(key = null, def = null) {
        return alone.get_arr(this.list(), key, def);
    },
    del(key) {
        if (alone.isset(key)) {
            if (alone.is_array(key)) {
                key.forEach((k) => window.localStorage.removeItem(k));
            } else {
                window.localStorage.removeItem(key);
            }
        }
    },
    delete() {
        window.localStorage.clear();
    },
    list() {
        const arr = {};
        const obj = window.localStorage;
        Object.keys(obj).forEach((key) => {
            const val = alone.to_obj(obj[key]) || {};
            if (val.time > 0 && alone.get_time() > val.time) {
                this.del(key);
            } else if (key && alone.isset(val.data)) {
                arr[key] = val.data;
            }
        });
        return arr;
    }
}